/// <reference types="react" />
import { IPublicModelPluginContext } from '@gant-lowcode/lowcode-types';
import { TreeMaster } from './controllers/tree-master';
export declare function OutlinePaneContext(props: {
    treeMaster?: TreeMaster;
    pluginContext: IPublicModelPluginContext;
    options: any;
    paneName: string;
    hideFilter?: boolean;
    onClose: () => void;
}): JSX.Element;
export declare const OutlinePlugin: {
    (ctx: IPublicModelPluginContext, options: any): {
        init(): Promise<void>;
        destroy(): void;
    };
    meta: {
        eventPrefix: string;
        preferenceDeclaration: {
            title: string;
            properties: {
                key: string;
                type: string;
                description: string;
            }[];
        };
    };
    pluginName: string;
};
